VirtualDubMod リリースノート
Cyrius:
- ネットモード関係のバグをいくつか修正しました。
- 空のLANGUAGEコメント('LANGUAGE=(null)'を選択するとクラッシュするバグを
  修正しました。
- VBR MP3ストリームをms単位でインターリーブするとおかしくなるバグを修正
  しました。(Doom9フォーラムの)Steven Greenbergさんから問題の指摘と解決策
  を頂きました。どうもありがとう。
- ファイルを開いたときに最初のフレームを表示するようにしました。
- OGMファイルからストリームを抜き出す時に発生する以下のバグを修正しました。
  * 空のSRTファイルが出力される
  * WAVヘッダ付きの抜き出しで、抜き出すストリームより長いファイルへ上書き
    をすると、出力ファイルの末尾に古いファイルの残骸が残ってしまう
- 起動時のリサイズ処理も無効にしました。他のリサイズ処理と同じく、#ifdefで
  囲ってあります。
- 外部プログラムから起動された際にジョブコントロールウィンドウを表示する
  ようにしました。
  GKnot等から起動されたときにクラッシュしてしまうのを避ける為の措置です。

Belgabor:
- わかりやすいように、メニューの構成を変えました。
- StreamさんとCyriusさんのネットモードへの修正を取り込みました
- この文書の名前を変更履歴に変えました
- 有効/無効を切りかえれるようになるまで、ウィンドウ自動リサイズ機能を
  一旦無効にしました。(virtualdub.hの#define行で再び有効にできます)
- ポジションバーへの目盛りの打ち方を次の中から選べるようにしました
  * 打たない
  * フレーム単位 (今までと同じ打ち方です)
  * 入力のキーフレーム単位
  * DivX3/XviDのstatsファイルに記録されたキーフレーム単位
    (statsファイルは「ツール→Statsファイルの読み込み」で読み込みます)
- Statsファイルを保存できるようにしました。
- Statsファイル中のキーフレームを切り替えられるようにしました。
  (デフォルトではスペースキーに割り当てられています)
- Statsファイルから読み込んだフレーム情報を表示するようにしました
  (Statsファイル関係の機能について:
   XviD関係の機能は完成です。(バグレポートや機能要望を歓迎します)
   今後は次のような機能を予定しています
   * DivX5のlogファイルをサポート
   * チャプターファイルやOGMのチャプター情報からの読み込み)

Stream:
- いくつかのバグを修正しました
  * ネットモードがエンコードの最終段階でエラーを出力し止まるバグ
  * ネットモードで長いパス名を使うとクラッシュするバグ
  * WAVファイルをAudioソースに指定すると、「環境を保存」で保存した
    スクリプトが読み込めないバグ
  * ネットモードで古い形式のAVIを出力できないバグ
  * ネットモードでOGMを出力できないバグ
  * ネットモードで非常に短いファイルを入力すると固まるバグ
  * ネットモードでMPEG2ファイルを入力すると固まるバグ
  * ネットモードでOGMファイルを入力すると固まるバグ
  * CBR MP3形式の外部ファイルをAudioソースに指定してMuxすると、音ずれ
    が発生するケースがあるバグ
  * OGMコメントに特殊な文字("や\など)が入っているとスクリプトエラーが
    発生するバグ
  * ジョブ実行中にどれか1つでもエラーが発生すると全てのジョブが止まって
    しまうバグ

[VirtualDubMod 1.4.13.1]
S_O & fccHandler (virtualdub.everwicked.com):
- Mpeg-1関係のバグを修正しました:
  * Audio Layer 1が正しく再生されない問題 (fccHandler)
    (NekoAmpのLayer2.cppを変更)
  * VBR Audioが正しく扱われない問題 (fccHandler)
  * 複数のVidio/Audioストリームを持ったMPEGファイルを正しく再生できない問題 (fccHandler)
  * Fixed the bug introduced by multiple stream-fix where mpegs with no 0xC0/0xE0 audio/video stream cannot be opened (S_O)
  * 「MPEGを開く」ダイアログのストリーム選択を動作するようにしました。 (S_O)
  * 中途半端なMPEGをデフォルトで読み込めるようにしました。 (警告は出します) (S_O)
  * 修正した中で一番ひどいバグ :
    「VirtualDubについて」ダイアログで飛び回る立方体が毎回同じポイントから飛び始めるバグを修正

Stone-D:
* ASFフォーマットのビデオをインポートできるようにしました。 [1]
* 以下の状況でメインウィンドウを自動的にリサイズする機能を追加しました。
  - AVIファイルを開く時
  - 入出力ペインの並びを切り替えたとき(縦に並ぶようにしたり、入れ替えたり)
  - ちょっと忘れちゃったけど、他にもいくつか ;)
* - 起動時にウインドウを画面の中央に持ってくるようにした。
* - ダビング中にプログラムを終了しようとしてもクラッシュしないようにした

[1] VirtualDub.h の "#define ALLOW_ASF_PARSING" を有効にしてください

Belgabor:
- ホットキーを設定できるようにしました。メインウィンドウ、キャプチャウィンドウ、そして
  スクリプトエディタが設定可能です。これに伴い、「最新の状態に更新」/「プレビュー」
  のホットキーを入れ替える設定ダイアログは廃止しました。
- P4バージョンのビルドが出来るようにしました。専用の設定を新たに追加しています。
  (コンパイルは可能にしましたが、私はP4を持っていないのできちんと動くかチェック
  出来ていません。気をつけてください。)
- スクリプトエディタのヘルプメニューから AviSynthのバージョンを確認できるようにしました。
- ヘルプを追加しました
- Audio、Audio2メニューから「OGG/Vorbis」を削除しました。そもそも動きませんし、
  ユーザの混乱の元になっているようですから。

Pulco-Citron:
- 「AVI情報」ウィンドウ : AC3ストリームの入ったファイルを開くと"unknown tag 2000"と表示されて
  いたのを修正しました。
- MPEG2を開く際にaudioストリームが("unknown audio stream"と表示され)自動認識されない場合ある
  バグを修正しました。まだ少し不完全です。とても小さなファイルでは依然、問題が発生するようです。
  vobファイルを開く際はsmartripperのテキストファイルが役に立つことを覚えておいてください。
- MPEG2インポートフィルタで生成されるファイルを出力するディレクトリを選択できるようにしました。
- MPEG2ファイルで、audioとインデックスのファイルを強制的に再生成させることができるようにしました。
- audioメニューに「CBR MP3」を追加しました。スクリプトにも同じ機能を追加しています。
- ジョブコントロールウィンドウを開いた時、自動的にホスト一覧を更新するのをやめました。
  LANが大規模な場合はホスト一覧を更新するのに、すごく時間がかかるからです。
  ホスト一覧の更新はユーザが明示的に「更新」ボタンを押して行ってください。

Cyrius:
- PNGファイルの保存をすると発生していたメモリーリークを修正しました。
- audioストリームを保存/分離する際に間違った進行状況が表示されるバグを修正しました。
- VirtualDub 1.4.13と統合しました
- (Nandubのように)AVI保存時に「タイトル」、「作者」、「著作権」、「コメント」を
  入力できるようにしました。
- Thomas-Matern氏のLANモードを統合しました。(http://www.matern-parkett.de/dub/)
  (LANがないので未テストです・・^^)
- ファイル位置を計算する際に外部Ogg/AC3/MP3/SRTストリームを計算に入れないバグを修正しました。
- マスク/削除されたサブセットの一部(最初からではなく)を保存する際に、音ずれが発生していた
  バグ(1.4.11.2で修正)がVBR audioでも発生していたので、修正しました。
- 内蔵のリサイズフィルタのGUIを変更しました。(mf氏の意見を参考にさせていただきました)
- OGMファイルでサブセットを定義しているとクラッシュする場合があるバグを修正しました。
- 「AVIをsegmentで出力」する際にどこでAVIを分割するかを決める方法を変更しました。
  以下の条件付きですが、基本的にキーフレームで分割を行います:
  * 「Video/Audioを変更せずにコピー」モードであること
  * 他のモードの場合はAudioのプリロードを使わないこと
  つまり、プリロード機能はキーフレームでの分割を「不可能」にしてしまうのです。
- OGMファイルを開く際、ストリームにオフセットがかかっているか「検出」を試みます。
  オフセットがかかっているようなら、その値を「入力の表示」画面でのデフォルト値にします。
- ジョブファイルの名前のデフォルトを.exeの名前をベースに決めることにしました。
  つまり、VirtualDubMod.exeをVirtualDub.exeにリネームすればデフォルトのジョブファイル名は
  VirtualDubMod.jobsからVirtualDub.jobsに変わります。[2]
- 「最新の情報に更新」を行うと「OGM→入力の表示」ウィンドウで選択していたファイルが消えて
  しまうバグを修正しました。
- 「指定容量での最終キーフレーム」機能にあったバグをいくつか修正しました。
  * 「OGM→入力の表示」で選択したストリームが計算に入れるようにしました。
  * ちょうど最終キーフレームとファイルの終端の間にあたる容量が入力された場合は最終キーフレーム
    にジャンプするようにしました。

[2] GordianKnotユーザにお知らせ : この修正は、現在のGKnotがバッチモードでVirtualDub.jobs
という名前のファイルしか使えないための代替手段です。GKnotと併用する場合は、VirtualDubMod.exe
をVirtualDub.exeにリネームしてください。

[VirtualDubMod 1.4.12.1]
Belgabor:
- スクリプトエディタ関係のバグフィックス
- AviSynth 2.07のキーワードを追加

Cyrius:
- VirtualDub 1.4.12と統合
- XviDのBフレームをサポートする特殊モードを追加
- DivX5で再圧縮を行った際に発生していた青色が落ちる現象を修正
- ジョブコントロールウィンドウに間違った経過ステータスが表示するバグを修正
- Ogg/AC3/MP3/SRT以外のストリームをOGMファイルから分離しようとするとクラッシュするバグを修正
- OGMストリームが"OGM入力"ウィンドウから分離/WAVに保存できるようになりました。
  もちろん、Ogg/SRTストリームにはWAVヘッダは付加されません。


[VirtualDubMod 1.4.11.2]
Belgabor:
- スクリプトエディタにScintillaを採用。SciLexer.dllとAviSynthLexer.lexerを入手してください。
  * AVISynthキーワードをカラー表示します。タイプエラーのように微妙な一致は赤く表示されます。
    外部キーワード(プラグインフィルター等)のカラー表示はAviSynthから情報を取る方法がわかる
    までペンディングです。パラメータヒントも同じ理由でペンディングとします。
  * Ctrl+スペース、あるいはShift+スペースでのキーワードを補完します。
  * 対応する括弧の強調表示。赤地に白文字は括弧にミスマッチが発生していることを示します。
  * Ctrl+Shift+Alt+C/Uで選択行をコメントアウト/解除します。
  * Ctrl+Iでサブセットをインポートできます。範囲指定して削除を行った結果残ったフレームに
    なりますので、Trim文に便利です。
- Syncを1.03にアップデート

Cyrius:
- Audio :
  * audioストリームを2つ持つAVIをプレビューするとクラッシュするバグを修正
  * audioデータが全て同じトラックに書き込まれるバグを修正。(つまり、2つ目のaudioトラック
    と生成後のAVIファイルは無意味になってしまっていました)
  * 形式の違う2つのaudioトラックを使えない(Nandubの)バグを修正
  * 「AVI情報」ウィンドウに2番目のaudioストリームの情報も表示するようにしました。
  * より正確な情報になるように「AVI情報」ウィンドウの「Preload skew」の表示に修正を加えました。
    以前はいくつかのケースで不適切な値が表示されていました。
    -> 「フレームモード(下記参照)」でMUXしたAC3ストリームでは1536サンプルしか表示されない
    -> NandubでMUXしたMP3ストリームでは1152サンプル近辺の値しか表示されない
       (ID3タグの有無やビットレートによって違いがありますが、おおよそ1152サンプル付近)
    このようなケースでは、データは値のとおりに不適切にMUXされてしまいます。
    それ以外の場合では、本当のpreload値は(同じではないにせよ)この近辺にあるといえる値を表示します。
  * 第1audioに「Audio入力[無し]」を選択し、第2audioで、「Audio入力[AVI]」を選択した場合、
    「保存[WAV]」で第2audioを保存するようにしました
  * 「音声の分離」機能を追加しました。WAVヘッダを付加しない以外は「保存[WAV]」と同じ機能です。
  * (Nandubのと同様に)ダビング中の情報に第2audioの項目を追加しました。
    OGM出力をする際は、"Audio2 data"フィールドにMUX中の他のストリームの情報もカウントされます。
  * 「Audio」→「第2ストリーム」をトップレベルメニュー : 「Audio2」 に移動しました。
  * AVIファイルのオープンに「Nandub VBR MP3互換モード」を追加しました。(デフォルトでは無効)
    このモードでNandubのようにVBR MP3ストリームを扱うことが出来ます。
    一応、このようなモードも用意しましたが、私としてはAVIではCBR、VBRならOGMフォーマットの利用を
    お勧めします。
  * AC3ファイルのオープンに「AC3フレームモード」を追加しました。(デフォルトでは無効)
    このモードを使うと、AC3ファイルをカットする際にフレーム境界でカットするように強制することが
    できます。実験ではうまく動いているようです。
  これら2つの機能は依然副作用の恐れがあるのでデフォルトで無効にしています。使う場合は充分注意して
  ください。ジョブリストに登録を行う場合は、使わないほうがいいです。
- GUI絡みの変更 :
  * 更新履歴/リリースノートのウィンドウをリサイズ可能に(ついでに少し大きく)しました。
  * OGM情報のウィンドウにも上記と同じ変更を加えました。
  * Hexエディタ、RIFFチャンクツリー、ジョブリスト、OGM入力/コメント、それから上記項目のウィンドウ
    それぞれにVirtualDubのアイコンを設定しました。
  * OGMファイルで表示されるファイル位置の情報をAVIファイルと同じようにより正確にしました。
- (Nandubの)容量指定で最終キーフレームに移動する機能を編集メニューに追加しました。
- クリップの最後に到達した際、マスク/削除されたサブセットがある場合、直前のキーフレームにシーク
  してしまう(VirtualDubの)バグを修正
- マスク/削除されたサブセットの一部(最初からではなく)を保存する際に、音ずれが発生していた
  (VirtualDub)のバグを修正
- VirtualDubModのジョブをVirtualDub.jobsのかわりに、VirtualDubMod.jobsに保存するようにした



[VirtualDubMod 1.4.11.1]
Cyrius:
- VirtualDubMod.vdi(デバッグ情報ファイル)を生成するようにプロジェクトの設定を変更。
  MapConv.exeが必要です。ソースコードはVirtualDubのWebサイトに、バイナリはCVSリポジトリ
  内のMapConv.zipにあります。
- OGMファイル内のストリームを分離できるようにまりました。分離は"OGM入力"ウィンドウから行って
  ください。分離後のストリームは下記のようにファイル保存されます。
  * Ogg Vorbis    → Oggファイル
  * AC3ストリーム → AC3ファイル
  * MP3ストリーム → MP3ファイル
  * SRTストリーム → SRTファイル(non-DOSフォーマット)
  それ以外のストリームは「保存[WAV]」のようにWAVヘッダをつけて分離されます。(しかし実験データ
  がないのでテストは行っていません)
  「保存[WAV]」と同じく、分離後のファイルはサブセットでカットされます。(それ専門のツールでは
  ないので、カットの精度には期待しないでください)

- VBR MP3ファイルを受け付けないバグを修正しました。しかしながら、VirtualDubのVBR訂正処理を
  通るので、適切な編集を行うことができません。
  他の大勢も言っていますが、私もAVIファイルにはVBRストリームを使わないほうがいいと思います。

Pulco-Citron:
- VirtualDub 1.4.11と統合しました(未テストの機能がたくさんあります)
- YV12の処理を修正しました。(sh0danさんのコード)
- Audio :
  * Audio/Ogg Vorbis Audioのメニュー項目を無効にしました。
  * Audioメニューの挙動を修正しました。(WAV音声を選んでもその状態が維持されない現象)
  * 2重音声の処理に関する些細なバグを修正しました。

Belgabor:
- AVSエディタを汎用スクリプトエディタにしました。
  * どんな種類のファイルでも開けます。avsファイルだった場合は自動的に動画を開きます。
  * かっこいいアイコンを用意しました ;)
  * ステータスバーにカーソル位置を表示するようにしました。
  * スクリプトエディタとメインウィンドウの連携を強化しました。
- VirtualDubと区別できるように、アプリケーションのアイコンをちょっと変更しました。
- その他、ちょっとした修正を行っています。


[VirtualDubMod 1.4.10.1 (was 0.1a)]
Belgabor:
- VirtualDubModのリリースノートとホームページへのリンクを追加しました。
- リリースノート表示用コンポーネントをRichEditに変更しました。
- AVSエディタ
  * [Toff]さんの微調整モードを追加しました。(詳しくはヘルプメニューを参照)



(Initial Combination)
Belgabor:
- 「最新の情報に更新」機能をメニューに加えました。編集中のファイルをリロードして
  現在と同じフレームを表示します
- 「最新の情報に更新」のホットキーを設定可能にしました(F5とCtrl+F5から選択。
  選ばなかった方のキーはプレビューに割り当てられます)
- 「AVISynth経由で開く」コマンドを追加しました。選択可能なテンプレートを元に
  適切なスクリプトを生成して、ビデオファイルを開くことが出来ます。
  テンプレートはVirtualDubModのフォルダにある'template'フォルダにあります。
  テンプレートの文法はAVISynthesizerと同じです。(詳しくは同梱のreadme_AVISynthesizer.txt
  をご覧ください)"Default"との記述から始まっているテンプレートが「開く」ダイアログで
  デフォルトとされます。(ファイル名では決定されませんので注意)
  きちんと動作をさせるには AVISynth 2.05以降が必要です。更に、プラグインディレクトリの設定
  も行ってください。(レジストリのHKEY_LOCAL_MACHINE\Software\Avisynth\に"PluginDir"という
  キーを作り、そこに設定します)あるいは、テンプレートに適切なLoadPlugin行を入れるという
  方法もあります。
- AVIエディタ (ホットキー Ctrl+E)
  * 「F2」か「Ctrl+S」で変更を保存します。
  * 「F5」で変更を保存し(バックアップは作成されません)、VirtualDubMod内の表示を更新します。
  * 間違ったAVSスクリプトも開いて、訂正し、「F5」で更新することができます。
- Andreas DittrichさんのSyncパッチを適用しました。

Pulco-Citron:
- MPEG2をサポートしました。
- YV12を部分的にサポートしました。
- AVIにMUXできるオーディオソースを追加しました。(たくさんのバグがあります)

Cyrius:
- OGMサポート:
  * OGMファイルを開くことができます。(開いたファイルの情報は「OGM」->「OGM情報」で参照できます)
  * OGM形式でファイルを保存することが出来ます。(「ファイル」→「名前をつけてOGMを出力」)
  * OGMファイルに外部のOgg/AC3/MP3/SRTファイルを追加することが出来ます。「OGM」→「入力の表示」
    で行ってください。
  * OGMストリームは「OGM」→「入力の表示」で管理できます。追加、削除、破棄、順序変更、コメント
    入力などが行えます。
  「Audio」や、「Audio」→「第2ストリーム」も依然OGMに使うことができますが、お勧めしません。
  videoストリームと2つのaudioストリームへのコメントも「OGM」→「入力の表示」で行ってください。
  コメント入力のヒント:
  - よく使われるコメントのタイプはリストから選択できます。
  - LANGUAGEコメントを選択すると(完全ではありませんが)言語を選択するリストが現れます。
  - SmartRipperやchapterXtractorで生成したチャプターをインポートすることができます。
    (KoepiさんのOggMuxのコードを参考にさせてもらいました)
    Nb : chapterXtractorでは"OGG"プリセットフォーマットを使って下さい。DVDDecrypterのOGGフォーマット
         も使えます。
- image sequenceの読み込み/保存にPNGをサポートしました。(保存時には16ビットカラーを使えません)
- AVI情報に(コンプレッサーの)FOURCCコードを追加しました。
